> For the complete documentation index, see [llms.txt](https://docs.struct.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.struct.com/api-reference/endpoints/dimensions.md).

# Dimensions

## GET /v1/Dimensions

> Get all dimensions added to the system

```json
{"openapi":"3.0.1","info":{"title":"Struct PIM Public API","version":"1.0"},"tags":[{"name":"Dimensions","description":""}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"","name":"Authorization","in":"header"}},"schemas":{"Struct.App.Api.Models.Dimension.DimensionModel":{"type":"object","properties":{"Uid":{"type":"string","description":"Unique id of dimension","format":"uuid"},"Alias":{"type":"string","description":"Unique alias of dimension","nullable":true},"Segments":{"type":"array","items":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionSegmentModel"},"description":"Segments available to this dimension","nullable":true}},"additionalProperties":false,"description":"Representation of a dimension to be used to segment attribute value data"},"Struct.App.Api.Models.Dimension.DimensionSegmentModel":{"type":"object","properties":{"Uid":{"type":"string","description":"Unique id of segment","format":"uuid"},"Identifier":{"type":"string","description":"Unique human readable identifier for segment","nullable":true},"Name":{"type":"string","description":"Display name for segment","nullable":true}},"additionalProperties":false,"description":"Represents a data segment in a dimension"}}},"paths":{"/v1/Dimensions":{"get":{"tags":["Dimensions"],"summary":"Get all dimensions added to the system","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionModel"}}}}}}}}}}
```

## POST /v1/Dimensions

> Add dimension to system

```json
{"openapi":"3.0.1","info":{"title":"Struct PIM Public API","version":"1.0"},"tags":[{"name":"Dimensions","description":""}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"","name":"Authorization","in":"header"}},"schemas":{"Struct.App.Api.Models.Dimension.DimensionModel":{"type":"object","properties":{"Uid":{"type":"string","description":"Unique id of dimension","format":"uuid"},"Alias":{"type":"string","description":"Unique alias of dimension","nullable":true},"Segments":{"type":"array","items":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionSegmentModel"},"description":"Segments available to this dimension","nullable":true}},"additionalProperties":false,"description":"Representation of a dimension to be used to segment attribute value data"},"Struct.App.Api.Models.Dimension.DimensionSegmentModel":{"type":"object","properties":{"Uid":{"type":"string","description":"Unique id of segment","format":"uuid"},"Identifier":{"type":"string","description":"Unique human readable identifier for segment","nullable":true},"Name":{"type":"string","description":"Display name for segment","nullable":true}},"additionalProperties":false,"description":"Represents a data segment in a dimension"},"Microsoft.AspNetCore.Mvc.ProblemDetails":{"type":"object","properties":{"Type":{"type":"string","nullable":true},"Title":{"type":"string","nullable":true},"Status":{"type":"integer","format":"int32","nullable":true},"Detail":{"type":"string","nullable":true},"Instance":{"type":"string","nullable":true}},"additionalProperties":{}}}},"paths":{"/v1/Dimensions":{"post":{"tags":["Dimensions"],"summary":"Add dimension to system","requestBody":{"description":"Dimension to add","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionModel"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionModel"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Microsoft.AspNetCore.Mvc.ProblemDetails"}}}}}}}}}
```

## PUT /v1/Dimensions

> Update a dimension in the system

```json
{"openapi":"3.0.1","info":{"title":"Struct PIM Public API","version":"1.0"},"tags":[{"name":"Dimensions","description":""}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"","name":"Authorization","in":"header"}},"schemas":{"Struct.App.Api.Models.Dimension.DimensionModel":{"type":"object","properties":{"Uid":{"type":"string","description":"Unique id of dimension","format":"uuid"},"Alias":{"type":"string","description":"Unique alias of dimension","nullable":true},"Segments":{"type":"array","items":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionSegmentModel"},"description":"Segments available to this dimension","nullable":true}},"additionalProperties":false,"description":"Representation of a dimension to be used to segment attribute value data"},"Struct.App.Api.Models.Dimension.DimensionSegmentModel":{"type":"object","properties":{"Uid":{"type":"string","description":"Unique id of segment","format":"uuid"},"Identifier":{"type":"string","description":"Unique human readable identifier for segment","nullable":true},"Name":{"type":"string","description":"Display name for segment","nullable":true}},"additionalProperties":false,"description":"Represents a data segment in a dimension"}}},"paths":{"/v1/Dimensions":{"put":{"tags":["Dimensions"],"summary":"Update a dimension in the system","requestBody":{"description":"Updated dimension","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionModel"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionModel"}}}}}}}}}
```

## DELETE /v1/Dimensions

> Delete a dimension in the system

```json
{"openapi":"3.0.1","info":{"title":"Struct PIM Public API","version":"1.0"},"tags":[{"name":"Dimensions","description":""}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"","name":"Authorization","in":"header"}}},"paths":{"/v1/Dimensions":{"delete":{"tags":["Dimensions"],"summary":"Delete a dimension in the system","parameters":[{"name":"uid","in":"query","description":"Uid of dimension","schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK"}}}}}}
```

## GET /v1/Dimensions/{uid}

> Get a specific dimension in the system

```json
{"openapi":"3.0.1","info":{"title":"Struct PIM Public API","version":"1.0"},"tags":[{"name":"Dimensions","description":""}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","description":"","name":"Authorization","in":"header"}},"schemas":{"Struct.App.Api.Models.Dimension.DimensionModel":{"type":"object","properties":{"Uid":{"type":"string","description":"Unique id of dimension","format":"uuid"},"Alias":{"type":"string","description":"Unique alias of dimension","nullable":true},"Segments":{"type":"array","items":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionSegmentModel"},"description":"Segments available to this dimension","nullable":true}},"additionalProperties":false,"description":"Representation of a dimension to be used to segment attribute value data"},"Struct.App.Api.Models.Dimension.DimensionSegmentModel":{"type":"object","properties":{"Uid":{"type":"string","description":"Unique id of segment","format":"uuid"},"Identifier":{"type":"string","description":"Unique human readable identifier for segment","nullable":true},"Name":{"type":"string","description":"Display name for segment","nullable":true}},"additionalProperties":false,"description":"Represents a data segment in a dimension"},"Microsoft.AspNetCore.Mvc.ProblemDetails":{"type":"object","properties":{"Type":{"type":"string","nullable":true},"Title":{"type":"string","nullable":true},"Status":{"type":"integer","format":"int32","nullable":true},"Detail":{"type":"string","nullable":true},"Instance":{"type":"string","nullable":true}},"additionalProperties":{}}}},"paths":{"/v1/Dimensions/{uid}":{"get":{"tags":["Dimensions"],"summary":"Get a specific dimension in the system","parameters":[{"name":"uid","in":"path","description":"Uid of dimension","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Struct.App.Api.Models.Dimension.DimensionModel"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Microsoft.AspNetCore.Mvc.ProblemDetails"}}}}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.struct.com/api-reference/endpoints/dimensions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
